//+------------------------------------------------------------------+
//|                                                Exp_HullTrend.mq5 |
//|                               Copyright  2014, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//+----------------------------------------------+
//| Handelsalgorithmen |
//+----------------------------------------------+
#include <TradeAlgorithms.mqh>
//+----------------------------------------------+
//| Enumeration Optionen fr die Berechnung der lots |
//+----------------------------------------------+
/*enum MarginMode  - ???????????? ????????? ? ????? TradeAlgorithms.mqh
  {
   FREEMARGIN=0,     //MM von der freien Mittel auf dem Konto
   BALANCE,          //MM vom Gleichgewicht der Mittel auf dem Konto
   LOSSFREEMARGIN,   //MM auf Verluste von der freien Mittel auf dem Konto
   LOSSBALANCE,      //MM fr Verluste vom Gleichgewicht der Mittel auf dem Konto
   LOT               //Lot ohne nderungen
  }; */
//+----------------------------------------------+
//| Beschreibung der Klasse CXMA |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+----------------------------------------------+
//| Deklaration einer Enumeration |
//+----------------------------------------------+
/*enum Smooth_Method - ???????????? ????????? ? ????? SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//| Deklaration einer Enumeration |
//+----------------------------------------------+
enum Applied_price_      //Der Typ der Konstanten
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simple Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4)
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price
   PRICE_DEMARK_         //Demark Price
  };
//+----------------------------------------------+
//| Eingabeparameter Experten des Indikators |
//+----------------------------------------------+
input double MM=0.1;              // Der Anteil der finanziellen Ressourcen der Anzahlung im Geschft
input MarginMode MMMode=LOT;      // Verfahren zur Bestimmung der Losgre
input int    StopLoss_=1000;      // Stop-Loss in Pips
input int    TakeProfit_=2000;    // Take Profit in Punkten
input int    Deviation_=10;       // Max. Abweichung des Preises in Punkten
input bool   BuyPosOpen=true;     // Die Berechtigung zum anmelden in Long
input bool   SellPosOpen=true;    // Die Berechtigung zum anmelden in Short
input bool   BuyPosClose=true;    // Die Erlaubnis zum verlassen der ??????
input bool   SellPosClose=true;   // Auflsung fr die Ausgabe von Shorts
//+----------------------------------------------+
//| Eingabeparameter des Indikators |
//+----------------------------------------------+
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_H4;// Zeitrahmen Indikator
input uint XLength=20;                           // Zeitraum der Anzeige
input Applied_price_ IPC=PRICE_CLOSE;            // Preis des Indikators
input Smooth_Method XMA_Method=MODE_LWMA;        // Die Methode der Mittelung
input int XPhase=15;                             // Der Parameter Glttung
//--- XPhase: fr JJMA einging innerhalb -100.. 100, Einfluss auf die Qualitt des bergangsprozesses
input uint SignalBar=1;                          // Zimmer Bar fr Signal Eingang
//+----------------------------------------------+
//--- Anzeige ganzzahligen Variablen Zeitraum fr die Speicherung von Grafiken in Sekunden
int TimeShiftSec;
//--- Anzeige von Ganzzahl-Variablen fr die Indikatoren ???????
int InpInd_Handle;
//--- Anzeige ganzzahlige Variablen vom Ursprung der Daten
int min_rates_total;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- erste ?????? Indikators HullTrend
   InpInd_Handle=iCustom(Symbol(),InpInd_Timeframe,"HullTrend",XLength,IPC,XMA_Method,XPhase);
   if(InpInd_Handle==INVALID_HANDLE)
     {
      Print(" ?? ??????? ???????? ????? ?????????? HullTrend");
      return(INIT_FAILED);
     }
//--- Initialisierung der Variablen fr die Speicherung von Grafik Periode in Sekunden
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);
//--- Initialisierung der Variablen Ursprung der Daten
   int SqrXLength=int(MathFloor(MathSqrt(XLength)));
//--- Initialisierung der Variablen Ursprung der Daten
   min_rates_total=GetStartBars(XMA_Method,XLength,XPhase);
   min_rates_total+=GetStartBars(XMA_Method,SqrXLength,XPhase);
   min_rates_total+=int(3+SignalBar);
//--- Abschluss der Initialisierung
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

   GlobalVariableDel_(Symbol());

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- berprfen Sie die Anzahl der Bars auf die Angemessenheit der fr die Berechnung der
   if(BarsCalculated(InpInd_Handle)<min_rates_total) return;
//--- Aktivierung der Geschichte um die korrekte Funktion IsNewBar() und SeriesInfoInteger()
   LoadHistory(TimeCurrent()-PeriodSeconds(InpInd_Timeframe)-1,Symbol(),InpInd_Timeframe);
//--- die Deklaration von lokalen Variablen
   double Ind[2],Sign[2];
//--- die Deklaration von statischen Variablen
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB;
//--- erkennen von Signalen fr Transaktionen
   if(!SignalBar || NB.IsNewBar(Symbol(),InpInd_Timeframe) || Recount) // die Prfung auf das Aussehen der neuen Bar
     {
      //--- ??????? Handelssignale
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;
      Recount=false;
      //--- kopieren Sie den neu generierten Daten in Arrays
      if(CopyBuffer(InpInd_Handle,0,SignalBar,2,Ind)<=0) {Recount=true; return;}
      if(CopyBuffer(InpInd_Handle,1,SignalBar,2,Sign)<=0) {Recount=true; return;}
      //--- erhalten Signale fr den Kauf
      if(Ind[1]>Sign[1])
        {
         if(BuyPosOpen && Ind[0]<=Sign[0]) BUY_Open=true;
         if(SellPosClose) SELL_Close=true;
         UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }
      //--- erhalten Signale zum Verkauf
      if(Ind[1]<Sign[1])
        {
         if(SellPosOpen && Ind[0]>=Sign[0]) SELL_Open=true;
         if(BuyPosClose) BUY_Close=true;
         DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }
     }
//--- Transaktionen
//--- Long schlieen
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);
//--- Short schlieen
   SellPositionClose(SELL_Close,Symbol(),Deviation_);
//--- Erffnung einer Long
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,MM,MMMode,Deviation_,StopLoss_,TakeProfit_);
//--- Open Short
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,MM,MMMode,Deviation_,StopLoss_,TakeProfit_);

  }
//+------------------------------------------------------------------+
